/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>
#include <locale.h>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, m, i, j, a, ll;
vector < vector < pair <int, int> > > v;
vector <int> s;
int l[9];
char c;
bool flag;
bool used[2010], used2[2010];

void check()
{
    int i, j;

    for(i = 0; i < n; i++)
        if(used[i] == false)
            break;

    fill(used2, used2 + n, false);
    used2[i] = true;
    s.clear();
    s.push_back(i);
    i = 0;
    while(i < s.size())
    {
        for(j = 0; j < v[s[i]].size(); j++)
            if(used[v[s[i]][j].X] == false && used2[v[s[i]][j].X] == false)
            {
                used2[v[s[i]][j].X] = true;
                s.push_back(v[s[i]][j].X);
            }

        i++;
    }

    if(ll + s.size() < n)
        return;

    for(i = 0; i < ll; i++)
        for(j = 0; j < v[l[i]].size(); j++)
            if(used[v[l[i]][j].X] == true && v[l[i]][j].X != l[(i - 1 + ll) % ll] && v[l[i]][j].X != l[(i + 1 + ll) % ll])
                return;

    for(i = 0; i < ll; i++)
        for(j = 0; j < v[l[i]].size(); j++)
            if(used[v[l[i]][j].X] == true)
                v[l[i]][j].Y++;

    for(i = 0; i < ll - 1; i++)
        printf("%d ", l[i] + 1);
    printf("%d\n", l[i] + 1);
}

void build(int index)
{
    int i, j;
    bool flag;

    if(index == 0)
    {
        for(i = 0; i < n; i++)
            for(j = 0; j < v[i].size(); j++)
                if(v[i][j].X > i && v[i][j].Y < 2)
                {
                    l[0] = i;
                    l[1] = v[i][j].X;
                    used[l[0]] = true;
                    used[l[1]] = true;
                    build(2);
                    used[l[0]] = false;
                    used[l[1]] = false;
                }
    }
    else if(index == ll)
    {
        flag = false;
        i = l[index - 1];
        for(j = 0; j < v[i].size(); j++)
            if(v[i][j].X == l[0] && v[i][j].Y < 2)
            {
                flag = true;
                break;
            }

        if(flag == true && i > l[1])
            check();
    }
    else
    {
        i = l[index - 1];
        for(j = 0; j < v[i].size(); j++)
            if(v[i][j].X > l[0] && v[i][j].Y < 2 && used[v[i][j].X] == false)
            {
                l[index] = v[i][j].X;
                used[v[i][j].X] = true;
                build(index + 1);
                used[v[i][j].X] = false;
            }
    }
}

int main()
{
    freopen("solid.in", "r", stdin);
    freopen("solid.out", "w", stdout);

    scanf("%d\n", &n);
    v.resize(n);
    for(i = 0; i < n; i++)
    {
        while(true)
        {
            scanf("%d", &a);
            a--;
            v[i].push_back(mp(a, 0));
            if(feof(stdin))
                break;
            scanf("%c", &c);
            if(c != ' ')
                break;
        }
    }

    fill(used, used + n, false);
    for(ll = 3; ll <= 8; ll++)
        build(0);

    for(i = 0; i < n; i++)
    {
        for(j = 0; j < v[i].size(); j++)
            if(v[i][j].Y < 2)
                break;

        if(j < v[i].size())
            break;
    }

    if(i < n)
    {
        s.clear();
        s.push_back(i);
        while(true)
        {
            i = v[i][j].X;

            if(i == s[0])
                break;

            for(j = 0; j < v[i].size(); j++)
                if(v[i][j].Y < 2 && v[i][j].X != s.back())
                    break;
            s.push_back(i);
        }

        if(s.size() > 0)
        {
            for(j = 0; j + 1 < s.size(); j++)
                printf("%d ", s[j] + 1);
            printf("%d\n", s[j] + 1);
        }
    }

    return 0;
}










