#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int m, n;



int main(){
    ifstream fin("privat.in");
    ofstream fout("privat.out");

    fin>>m>>n;
    vector< vector<int> > f(m+2, vector<int>(n+2, 0));
    vector< vector<int> > curr(m+2, vector<int>(n+2, 0));
    vector< vector<int> > next(m+2, vector<int>(n+2, 0));
    vector< vector<char> > ans(m+2, vector<char>(n+2));

    //READ FILE
    int i,z;
    for(i=1; i<=m; i++){
        for(z=1; z<=n; z++){
            fin>>f[i][z];
        }
    }
    f[m][1]=0;

    //FILLING STARTINGS
    for(i=1; i<=n; i++){
        curr[1][i]=f[1][i];
    }
    for(i=1; i<=m; i++){
        curr[i][n]=f[i][n];
    }

    //MAIN PART
    for(i=2; i<=m; i++){
        for(z=n-1; z>=1; z--){

            if(curr[i-1][z]>=curr[i][z+1]){
                //UP
                ans[i][z]='u';
                next[i][z]=curr[i-1][z];
                curr[i][z]=f[i][z]+next[i-1][z];
            } else {
                //RIGHT
                ans[i][z]='r';
                next[i][z]=curr[i][z+1];
                curr[i][z]=f[i][z]+next[i][z+1];
            }

        }
    }


    //FILE OUT
    i=m;
    z=1;
    fout<<next[i][z]<<' '<<curr[i][z]<<endl;
    do{
        if(ans[i][z]=='u'){
            i--;
            fout<<'u';
        } else {
            z++;
            fout<<'r';
        }
    }while(i>1 && z<n);
    fout<<endl;

    fin.close();
    fout.close();
    return 0;
}
