/* GCC */
#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <sstream>
#include <algorithm>

using namespace std;

const int nmax = 20000;
int n, m, mas[nmax], dp[nmax], parity = 0, v1 = 0, v2 = 0;
bool go[nmax];
string s;
int f(int a, int b) {
    return (a - 1) * m + b;
}

int main() {
    freopen("privat.in", "r", stdin);
    freopen("privat.out", "w", stdout);
    int i, j;
    cin >> n >> m;
    for(i = 1; i <= n; i++)
        for(j = 1; j <= m; j++)
        cin >> mas[f(i, j)];
    for(i = 1; i <= n; i++) {
        dp[f(i, m)] = mas[f(i, m)];
        go[f(i, m)] = true;
    }
    for(i = 1; i <= m; i++) {
        dp[f(1, i)] = mas[f(1, i)];
        go[f(1, i)] = false;
    }
    for(i = 2; i <= n; i++)
        for(j = m - 1; j >= 1; j--) {
            int u = mas[f(i - 1, j)], r = mas[f(i, j + 1)];
            if(go[f(i - 1, j)])
                u += dp[f(i - 2, j)];
            else
                u += dp[f(i - 1, j + 1)];
            if(go[f(i, j + 1)])
                r += dp[f(i - 1, j + 1)];
            else
                r += dp[f(i, j + 2)];
            if(u >= r) {
                dp[f(i, j)] = u;
                go[f(i, j)] = true;
            }
            else {
                dp[f(i, j)] = r;
                go[f(i, j)] = false;
            };
        }
    if(m == 2)
        go[f(n, 1)] = false;
    if(n == 2)
        go[f(n, 1)] = true;

    for(i = n, j = 1; i != 1 && j != m; parity++) {
            if(go[f(i, j)])
                s += 'u', i--;
            else
                s += 'r', j++;
            if(parity & 1)
                v2 += mas[f(i, j)];
            else
                v1 += mas[f(i, j)];
    }
    cout << v1 << ' ' << v2 << endl;
    cout << s << endl;
}
