/* GCC */
#include <iostream>
#include <string>
#include <fstream>

using namespace std;

const int MAX=1e3+1;

int n, m;
int arr[MAX], adp[MAX];
char ans[MAX];

template <class T>
T& get(T* a, int x, int y)
{
    return a[m*(x-1)+y];
}

int main()
{
    ifstream cin("privat.in");
    ofstream cout("privat.out");
    ios::sync_with_stdio(0);
    cin >> n >> m;
    for(int i=1; i<=n; ++i)
        for(int j=1; j<=m; ++j)
            cin >> get(arr, i, j);
    for(int i=1; i<=n; ++i)
        get(adp, i, m)=get(arr, i, m), get(ans, i, m)='u';
    for(int j=1; j<=m; ++j)
        get(adp, 1, j)=get(arr, 1, j), get(ans, 1, j)='r';
    for(int i=2; i<=n; ++i)
    {
        for(int j=m-1; j>=1; --j)
        {
            int up, right;
            if(get(ans, i-1, j)=='r') up=get(adp, i-1, j+1);
            else up=get(adp, i-2, j);
            if(get(ans, i, j+1)=='u') right=get(adp, i-1, j+1);
            else right=get(adp, i, j+2);
            up+=get(arr, i-1, j);
            right+=get(arr, i, j+1);
            if(up>=right)
            {
                get(adp, i, j)=up;
                get(ans, i, j)='u';
            }
            else 
            {
                get(adp, i, j)=right;
                get(ans, i, j)='r';
            }
        }
    }
    int x=n, y=1, now=0, cnt[2]={0};
    string s;
    while(x!=1&&y!=m)
    {
        s+=get(ans, x, y);
        if(get(ans, x, y)=='u') --x;
        else ++y;
        cnt[now]+=get(arr, x, y);
        now=!now;
    }
    cout << cnt[0] << " " << cnt[1] << endl << s << endl;
    return 0;
}
