#include <iostream>
#include <fstream>
#include <string>
using namespace std;
struct Step
{
    int fw , sw;
    string way;
};
string rev(string pS)
{
    string ans;
    for(int i = pS.length() - 1;i >= 0;i--)
        ans.push_back(pS[i]);
    return ans;
}
int m , n;
int arrM[12346][12346];
Step PrF(int i,int j)
{
    if(i == m - 1)
        if((j + i) & 1)
            return {arrM[i][j] , 0 , ""};
        else
            return {0 , arrM[i][j] , ""};
    if(j == n - 1)
        if((j + i) & 1)
            return {arrM[i][j] , 0 , ""};
        else
            return {0 , arrM[i][j] , ""};
    Step hV1 , hV2;
    hV1 = PrF(i + 1,j);
    hV2 = PrF(i,j + 1);
    if((j + i) & 1)
        {
            if(hV1.sw > hV2.sw)
                return {hV1.fw + arrM[i][j] , hV1.sw , hV1.way + 'u'};
            if(hV1.sw == hV2.sw)
                if(hV1.fw > hV2.fw)
                    return {hV1.fw + arrM[i][j] , hV1.sw , hV1.way + 'u'};
                else
                    return {hV2.fw + arrM[i][j] , hV2.sw , hV2.way + 'r'};
            return {hV2.fw + arrM[i][j] , hV2.sw , hV2.way + 'r'};
        }
    else
        {
            if(hV1.fw > hV2.fw)
                return {hV1.fw , arrM[i][j] + hV1.sw , hV1.way + 'u'};
            if(hV1.fw == hV2.fw)
                if(hV1.sw > hV2.sw)
                    return {hV1.fw , arrM[i][j] + hV1.sw , hV1.way + 'u'};
                else
                    return {hV2.fw , arrM[i][j] + hV2.sw , hV2.way + 'r'};
            return {hV2.fw , arrM[i][j] + hV2.sw , hV2.way + 'r'};
        }

}
int main()
{
    ifstream fin("privat.in");
    fin >> m >> n;
    for(int i = m - 1;i >= 0;i--)
    {
        for(int j = 0;j < n;j++)
            fin >> arrM[i][j];
    }
    ofstream fout("privat.out");
    Step hV1 = PrF(0,1),hV2 = PrF(1,0);
    if(hV1.fw > hV2.fw)
    {
        fout << hV1.fw << ' ' << hV1.sw << endl;
        fout << rev(hV1.way + 'r')<< endl;
    }
    else
    {
        fout << hV2.fw << ' ' << hV2.sw << endl;
        fout << rev(hV2.way + 'u')<< endl;
    }
    return 0;
}
